<?php
//  ------------------------------------------------------------------------ //
//                           PHP-ServerError                                 //
//                     Copyright (c) 2003,2004 indyone                       //
//                                   2004,2007,2008 edgar soldin             //
//                  <http://www.servererror.net/info/>                       //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //

define("PROGRAM","Servererror-PHP");
define("VERSION","0.31");
define("LASTMODDATE","04.08.2008");
define("AUTHORS","Ioannis Stavrinos,". 
	 							 "indyone at ee dot teiath dot gr,".
	 							 "http://nemesis.ee.teiath.gr/~indyone; ".
	 							 "Edgar Soldin,".
	 							 "edgar at servererror dot net,".
	               "http://www.soldin.de");
define("COPYRIGHT","2004 Ioannis Stavrinos, Edgar Soldin");
define("LICENSE","GNU General Public License, http://www.gnu.org");


/*
	PHP-ServerError version 0.31
	
	PHP-Coded by 
	 Ioannis Stavrinos, 
	 indyone at ee dot teiath dot gr, 
	 http://nemesis.ee.teiath.gr/~indyone
	
	Original script, idea and some more PHP 
	 by Edgar Soldin, 
	 edgar at servererror dot net, 
	 http://www.soldin.de
	 
	More information about this script go to http://www.servererror.net/info
		
	Description: 
	 This is the PHP version of the original script of www.servererror.net 
	 which shows a fake (funny) server error message each time it is requested.
		
	Tip: 
	 Force to show an error message by entering the line number in the query 
	 string of the url	eg. http://www.myserver.org/notexists.html?24 
	 This will show the	error message in the 24th line. Note that the displayed
	 error code will have the given number plus 600 as the fake errors start at
	 this value. 
*/
/*
	Options:
	 The relative or absolute path to the file with the error codes.
	 This file must have in each line, one error message.
	 The lines that are empty or start with // are ignored.
*/	
$error_filename = 'info/FakeErrorcodes.txt';
/*
	 The relative or absolute path to the template file, which will be used to create
	 the look & feel of the error page.
	 
	 You can use one of the following options:
      'apache'           - an original Apache error page design
      'iis'              - an Microsoft IIS error page design
      'servererror_new'	 - a new redesign of the original design
      'servererror_old'  - the traditional servererror.net page look (was a modified 
	 	                   Netscape webserver error design)
*/
$error_template = 'servererror_new';
/*
	The error codes starts from the following number.
	eg. if $start_number = 600, the line #10 has the error code 610
*/
$start_number = 600;

/*
	Don't edit the following unless you know what you are doing ;-)
*/
if (!file_exists($error_filename)) {
	$error_code = 0;
	$error_message = 'The server has failed to analyse the request error because the file that has the error codes is not readable.';
} 
elseif ($_SERVER['QUERY_STRING'] == 'list'){
	$contents = file($error_filename);
	foreach ($contents as $line) {
		// decide whether it's a hint or a message or a title
		if ( preg_match('/^[-\s\/]/', $line) ){
			continue;
		}elseif ( preg_match("/^\+(.*)/", $line, $match) ){
			$error_tips[count($error_tips)-1] = $match[1];
		}else { 
			$error_tips[] = $line;	  
		}
		$number = count($error_tips)-1;
		$error_tips[count($error_tips)-1] = "<a href=\"server_error?$number\">".str_truncate("Servererror ".($start_number+count($error_tips)-1).': '.get_parsed_string($error_tips[count($error_tips)-1]),100)."</a>";
	}
	$error_message = "A list of all current server errors.";
	$error_title = "Server Error List";
	$start_number = 000;
}
else {
	$contents = file($error_filename);
	//ereg('[0-9]*', substr(strrchr($_SERVER['REQUEST_URI'], '?'), 1), $force_code);
	preg_match("/^(.*)\?([0-9]*)$/",$_SERVER['REQUEST_URI'],$force_code);
	$force_code = $force_code[2];
	
	$errors = array();
	foreach ($contents as $line) {		
		// decide whether it's a hint or a message or a title
		if ( preg_match('/^[\s\/]/', $line) ){
			continue;
		}elseif ( preg_match("/^\+(.*)/", $line, $match) ){
			$errors[count($errors)-1]->title = $match[1];
		}elseif ( preg_match("/^-(.*)/", $line, $match) ){
			$errors[count($errors)-1]->tips[] = $match[1];
			//print_r($errors[count($errors)-1]->tips); echo "H<br>";
		}else { 
			$errors[] = new Error($line);
			//echo $error->msg."<br>";  
		}
		//$error_message = trim($contents[$error_code]);
	}
	
	
	// create a random number OR take the one given in URL
	$error_code = !is_null($force_code) ? (int)$force_code : rand(0, sizeof($errors)-1);
	
	if($error_code>(count($errors)-1) || $error_code<0){
		$error_message = "The error code $error_code is currently unknown. Use a code between 0 and ".count($errors)." for a proper error.";			
	}else {
		$error_message = get_parsed_string($errors[$error_code]->msg);
		$error_tips = get_parsed_string($errors[$error_code]->tips);
		$error_title = get_parsed_string($errors[$error_code]->title);
	}

}


$error_code += $start_number;
$error_url = substr($_SERVER['PHP_SELF'], 0, strrpos($_SERVER['PHP_SELF'], '/'));
$error_protocol = strtoupper($_SERVER['SERVER_PROTOCOL']);
$error_host = $_SERVER['SERVER_NAME'];
$error_port = $_SERVER['SERVER_PORT'];
include('templates/'.$error_template.'.php');

/**
 * an error object to hold the attributes
 */
class Error{
	var $msg = "";
	var $title = "";
	var $tips = array();
	
	function Error($msg){ if(!empty($msg)) $this->msg = $msg; }
}

/**
 * A handler to dynamically insert text for placeholders eg. error 626
 */
function handler_error($param,$content){
	if ($param == 'ten_years_ago')
		return strftime('%R:%S the %d.%b.').(strftime('%Y')-10);
}

/**
 * truncates a string (from smarty)
 *
 * @param string  the string to manipulate
 * @param int     the length to cut to
 * @param string  the string to append (default:'...')
 * @param boolean whether to break between words only (default: true)
 * @param boolean
 *
 * @return string the manipulated string
 */
function str_truncate($string, $length = 80, $etc = null,
                        $break_words = false, $middle = false)
{
    if ($length == 0)
        return '';

    if (is_null($etc))
        $etc = '...';

    if (strlen($string) > $length) {
        $length -= strlen($etc);
        if (!$break_words && !$middle) {
            $string = preg_replace('/\s+?(\S+)?$/', '', substr($string, 0, $length+1));
        }
        if(!$middle) {
            return substr($string, 0, $length).$etc;
        } else {
            return substr($string, 0, $length/2).$etc.substr($string, -$length/2);
        }
    } else {
        return $string;
    }
}

/**
 * Parses the string for placeholders (pchs) and area pchs and replaces them.
 *
 * The syntax is:
 *      <!--$var-->
 *      <!--$area_var--><!--$/area_var-->
 * or for handler usage:
 *      <!--$handlername:handlerparams-->
 *      <!--$areahandlername:handlerparams--><!--$/areahandlername-->
 *
 * @param string the text to parse
 * @param array  a context containing the vars to replace pchs
 * @param array  handler(s) to add to handler stack
 * @param array  options
 *
 * @return string the parsed string
 */
function get_parsed_string( $text, $context = null,
                            $handlers = array(), $options = array() ) {

	// no context given, take GLOBALS
	if (!is_array($context))
		$context =& $GLOBALS;

    // default is to clean up, to say fill empty vars
    if (!array_key_exists('cleanup', $options))
        $options['cleanup'] = true;

	// default handlers, can be overwritten by parameter
	//$handlers =& $GLOBALS[basename(__FILE__)]['handlers'];
    $handlers = array_merge(array('error'=>'handler_error'),
                                $handlers);

	//debug(__FILE__." (".__LINE__.") -> handlers = ".join(', ',array_keys($handlers)));

	$counter = 0;
	do{
		/***
		 * Ersetzen von Variablen/Array-Platzhaltern im String
		 * z.B.
		 * (Neues Format)
		 * <!--$Array/Key1/Value-- >
		 * <!--$Variable-->
		 *
		 * (Altes Format)
		 * #$Variable$#
		 * #$Array/Key/Value$#
		 *
		 * Sonderbehandlung: Altes Format und Neues Format beginnend mit
		 * Unterstrich z.B. <!--$_Variable-->, #$Variable$# werden roh ausgegeben.
		 * Alle anderen Variablen, Arraywerte werden mit htmlentities() escaped.
		 *
		 */
		$delim = '';
		if (!$regexp = (isset($options['regexp']) && $options['regexp']))
            $regexp = array('(<!--|#)\$','(\$#|-->)');
		$regexp_opt = 'U';
        $area_regexp = array($regexp[0].'([^/][^:]+)(\:(.*))?'.$regexp[1],
                             $regexp[0].'(/\2)'.$regexp[1].'');
		$area_regexp_opt = 'Us';
		$counter++;
		$replaced = false;

		//preg_match_all($delim.$regexp[0].'(.+)'.$regexp[1].$delim.$regexp_opt, $text, $matches);
        //debug('ALL: '.htmlentities(print_r($matches,true)));

        $pregexp = $delim.$area_regexp[0].'(?:(?:'.'(.+)'.$area_regexp[1].')|)'.$delim.$area_regexp_opt;
        preg_match_all($pregexp, $text, $area_matches, PREG_SET_ORDER);
//        debug(htmlentities($pregexp));
        //debug('ALLAREA: '.(int)translate_enabled().' '.htmlentities(print_r($area_matches,true)));
        foreach($area_matches as $area_match){        	
        	$area_match = array_pad($area_match, 10, '');        	
        	
            $full_monty = $area_match[0];
            $name = $handler = $area_match[2];
            $is_area = (count($area_match)>6);
            $area_content = $area_match[6];
            $is_handler = (boolean)strlen($area_match[3]);
            $handler_param = $area_match[4];
            $wrap_in = $area_match[1];
            $wrap_out = $area_match[5];
            $tag_in = $area_match[1].'$'.$area_match[2].$area_match[3].$area_match[5];
            $tag_out = $area_match[7].'$'.$area_match[8].$area_match[9];

    // ATTENTION: deactivated this part, as it replaces the plch _before_ the match
    //            could be found in translation database
//            // replace plchs in areas first
//            $area_parse_params = func_get_args();
//            $area_parse_params[0] = $area_content;
//            if ($is_area
//                && ( $array = call_user_func_array(__FUNCTION__, $area_parse_params) )
//                && $area_content !== $array ) {
//
//                // wrap it in area tags again
//                $array = $tag_in.$array.$tag_out;
//                // the area is processed on next turn
//            }
            // placeholders for explicit files, area constants ..
			// to say .. definable handler support
			if ($is_handler){

                // check if defined .. else silently ignore
                if (!array_key_exists($handler, $handlers))
                    continue;

				//debug(basename(__FILE__)." (".__LINE__.") -> handlers[".$handler."] = ".$function);
				if (is_callable($function = (string)$handlers[$handler],false)){
					// check if handler is disabled
                    if (is_callable($function."_enabled", false) && !call_user_func($function."_enabled")){
//                        debug(basename(__FILE__)."::get_parsed_string() the handler '$handler' ".
//                              "is disabled.");
                        continue;
                    }

                    $array = $function($handler_param, $is_area?$area_content:null);

                    //debug("parse handler call $function($param, $area_content)");

//                    if (is_callable($function."_replacing", false) && !call_user_func($function."_replacing")){
//                        debug(basename(__FILE__)."::get_parsed_string() the handler's '$handler' replacing ".
//                              "is disabled.");
//                        continue;
//                    }

				}
				else{
					//debug(basename(__FILE__)."::get_parsed_string() the handler '$handler' results in callback function '$function' which is uncallable.");
					// for areas the default value is the content
					if ($is_area)
						$array = $area_content;
					else
						$array = null;
				}
			}
			// ordinary placeholders
			else {
                //debug(basename(__FILE__)."::get_parsed_string() the placeholder '$name' is looked up in context.");

				// fetch value from context
				$keys = explode('/', $name);
				$array= array();
				for($i=0;$i<count($keys);$i++){
					$key = $keys[$i];
					if ($i == 0 && $i < count($keys) && array_key_exists($key,$context))
						$array = $context[$key];
					elseif($i > 0 && $i < count($keys) && is_array($array) && array_key_exists($key,$array) && is_array($array[$key]))
						$array = $array[$key];
					elseif($i == (count($keys)-1) && is_array($array) && array_key_exists($key,$array))
						$array = $array[$key];
					else{
						//debug("Stoppe bei: $key=>$array");
						$array = null;
						break;
					}
				}

			}

            // default content for areas is the existing content
            if (is_null($array) && $is_area)
                $array = $area_content;

			//debug("Gefundene Platzhalter: ".htmlentities($match).'='.strlen($array));
			if (!is_null($array) || $GLOBALS['INC_PARSE']['REPLACE']['cleanup'] || $options['cleanup']) {
//				debug('Ersetze: '.htmlentities(($is_area?'AREA':'PLCH')." $full_monty")
//								.' <p>durch</p>'.htmlentities($array));
				// escape strings or not or what?
				$escapeoff = (isset($options['raw']) && $options['raw']) //
                             || preg_match("/^_(?!REQUEST|SERVER|SESSION|GET|POST)/",$name) // all vars beginning with '_' stay unescaped except of phps input vars
							 || preg_match("/#$/",$wrap_in) // old style placeholders
							 || $is_handler // handler output stays as it is delivered
							 || $is_area ? true : false;        // areas are taboo
				//debug(__FILE__." (".__LINE__.") -> escape is ".(!$escapeoff?'ON':'OFF'));
				$value = $escapeoff ? (string)$array : nl2br(htmlentities((string)$array));
				// replacement time
				$text = preg_replace($delim.preg_quote($full_monty, $delim).$delim, $value, $text);

                if ( $is_handler && ( is_callable($function."_replacing", false)
                                      && !call_user_func($function."_replacing") )
                    )
                    ;// don't recognize this as an replacement
                else
                    $replaced = true;
			}
		}
	}while($replaced & ($break = ($counter < 100)));

	//debug( "Drehte $counter Ersetzungsrunden. (".(int)$break.")");
	//if (!$break)
		//debug( "Habe die Ersetzung abgebrochen, da das Rundenlimit erreicht wurde.");

	return $text;
}

?>